# Copyright 2020 kubeflow.org.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# coding: utf-8

"""
    KFServing

    Python SDK for KFServing  # noqa: E501

    OpenAPI spec version: v0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class V1alpha2Batcher(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'max_batchsize': 'int',
        'max_latency': 'int',
        'timeout': 'int'
    }

    attribute_map = {
        'max_batchsize': 'maxBatchSize',
        'max_latency': 'maxLatency',
        'timeout': 'timeout'
    }

    def __init__(self, max_batchsize=None, max_latency=None, timeout=None):  # noqa: E501
        """V1alpha2Batcher - a model defined in Swagger"""  # noqa: E501

        self._max_batchsize = None
        self._max_latency = None
        self._timeout = None
        self.discriminator = None

        if max_batchsize is not None:
            self.max_batchsize = max_batchsize
        if max_latency is not None:
            self.max_latency = max_latency
        if timeout is not None:
            self.timeout = timeout

    @property
    def max_batchsize(self):
        """Gets the max_batchsize of this V1alpha2Batcher.  # noqa: E501

        MaxBatchSize of batcher service  # noqa: E501

        :return: The max_batchsize of this V1alpha2Batcher.  # noqa: E501
        :rtype: str
        """
        return self._max_batchsize

    @max_batchsize.setter
    def max_batchsize(self, max_batchsize):
        """Sets the max_batchsize of this V1alpha2Batcher.

        MaxBatchSize of batcher service  # noqa: E501

        :param max_batchsize: The max_batchsize of this V1alpha2Batcher.  # noqa: E501
        :type: str
        """

        self._max_batchsize = max_batchsize

    @property
    def max_latency(self):
        """Gets the max_latency of this V1alpha2Batcher.  # noqa: E501

        MaxLatency of batcher service  # noqa: E501

        :return: The max_latency of this V1alpha2Batcher.  # noqa: E501
        :rtype: str
        """
        return self._max_latency

    @max_latency.setter
    def max_latency(self, max_latency):
        """Sets the max_latency of this V1alpha2Batcher.

        MaxLatency of batcher service  # noqa: E501

        :param max_latency: The max_latency of this V1alpha2Batcher.  # noqa: E501
        :type: str
        """

        self._max_latency = max_latency

    @property
    def timeout(self):
        """Gets the timeout of this V1alpha2Batcher.  # noqa: E501

        Timeout of batcher service  # noqa: E501

        :return: The timeout of this V1alpha2Batcher.  # noqa: E501
        :type: str
        """
        return self._timeout

    @timeout.setter
    def timeout(self, timeout):
        """Sets the timeout of this V1alpha2Batcher.

        Timeout of batcher service  # noqa: E501

        :param timeout: The timeout of this V1alpha2Batcher.  # noqa: E501
        :type: str
        """
        self._timeout = timeout

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(V1alpha2Batcher, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1alpha2Batcher):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
